-------------------------------------------------------------- 
--  Subject : Binary trees
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

  constant
    Key   = 1
    Left  = 2
    Right = 3
  end

  function PreOrder( Root )              
    if not Null( Root ) then
      writeln( Root[ Key ] )
      PreOrder( Root[ Left ] )
      PreOrder( Root[ Right ] )
    end
  return 0

  function InOrder( Root )    
    if not Null( Root ) then
      InOrder( Root[ Left ] )
      writeln( Root[ Key ] )
      InOrder( Root[ Right ] )
    end
  return 0

  function PostOrder( Root ) 
    if not Null( Root ) then
      PostOrder( Root[ Right ] )
      PostOrder( Root[ Left ] ) 
      writeln( Root[ Key ] )
    end
  return 0

  function PrtTree( Root )
    writeln( '')
    writeln( Str( Root ) )
  return 0

  function Update( var Root, X )
    if NULL( Root ) then
      Root := array( 3 ) 
      Root[ Key ] := X
    else
      if    X < Root[ Key ] then
        Update( Root[ Left ], X )       
      elsif X > Root[ Key ] then
        Update( Root[ Right ], X )    
      end
    end
  return 0

  function Search( Root, X )
    P == Root
    if not Null( P ) then
      if P[ Key ] = X then
        R == P
      elsif X < P[ Key ] then
        R == Search( P[ Left ], X )
      else
        R == Search( P[ Right ], X )     
      end
    end 
  return R

  function Delete( var Root, X )       
    R == Search( Root, X )

    if not Null( R ) then
      NullLeft  := Null( R[ Left  ] )
      NullRight := Null( R[ Right ] )             
      if NullLeft and NullRight then 
        Destroy( @R )
      elsif NullLeft then
        Temp << R[ Right ] 
        Destroy( @R )     
        R << Temp  
      elsif NullRight then
        Temp << R[ Left ]       
        Destroy( @R )     
        R << Temp  
      else
        P == R[ Left ]
        while not Null( P[ Right ] ) do
          P == P[ Right ]
        end
        R[ Key ] := P[ Key ]
        Temp << P[ Left ]       
        Destroy( @P )     
        P << Temp  
      end
    end
  return 0

  ------------- Main program -------------

  Update( Tree, 10 )
  Update( Tree, 5  )
  Update( Tree, 15 )
  Update( Tree, 3  )
  Update( Tree, 8  ) 
  Update( Tree, 13 )
  Update( Tree, 18 )

  PreOrder( Tree )
  writeln( '' )
  InOrder( Tree ) 
  writeln( '' ) 
  PostOrder( Tree ) 

  PrtTree( Tree )

  Delete( Tree, 13 )
  PrtTree( Tree ) 

  Delete( Tree, 15 ) 
  PrtTree( Tree ) 

  Delete( Tree, 8888 )     
  PrtTree( Tree ) 

  Delete( Tree, 5 )  
  PrtTree( Tree ) 

  Delete( Tree, 10 )   
  PrtTree( Tree ) 

  Delete( Tree, 8 )    
  PrtTree( Tree ) 

  Inorder( Tree )
return








