unit demofrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Virtcomp, StdCtrls, Menus;
type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    VirtComp1: TVirtComp;
    VirtComp3: TVirtComp;
    VirtComp4: TVirtComp;
    VirtComp5: TVirtComp;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    VirtComp8: TVirtComp;
    VirtComp9: TVirtComp;
    VirtComp10: TVirtComp;
    MainMenu1: TMainMenu;
    Help1: TMenuItem;
    Virtlanguagemanual1: TMenuItem;
    WorkingwithVIRT1: TMenuItem;
    ComponentTVirtComp1: TMenuItem;
    N1: TMenuItem;
    Abour1: TMenuItem;
    VirtComp2: TVirtComp;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Virtlanguagemanual1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComponentTVirtComp1Click(Sender: TObject);
    procedure WorkingwithVIRT1Click(Sender: TObject);
    procedure Abour1Click(Sender: TObject);
    procedure VirtComp1BeforeParsing(var Sender: TVirtComp);
    procedure VirtComp9BeforeParsing(var Sender: TVirtComp);
  private
    { Private declarations }
    TempVirt : TVirtComp;
  public
    { Public declarations }
  end;
var
  Form1: TForm1;

implementation

{$R *.DFM}

var
  OldWndProc : TFNWndProc;
  WinVirtComp   : TVirtComp;

function NewWndProc(
  Handle : HWND; Msg : UINT;
  wparam: WPARAM; lparam: LPARAM) : LRESULT; stdcall;
var
  Res : Variant;
begin
  Result := CallWindowProc( OldWndProc,
            Handle, Msg, wparam, lparam );

  case Msg of
    WM_PAINT, WM_CLOSE :
      WinVirtComp.ExecFunction( 'TForm.WindowProc', [ Handle, Msg ], Res );
  end;
end;

procedure _TForm_Init;
var
  F : TForm;
  Owner : Integer;
begin
  F := TForm.Create( RunVirtComp.Owner );

  OldWndProc :=
    TFNWndProc( GetWindowLong( F.Handle, GWL_WNDPROC) );
  SetWindowLong( F.Handle,
    GWL_WNDPROC, Longint(@NewWndProc) );

  F.Height := RunVirtComp.PopVar;
  F.Width  := RunVirtComp.PopVar;
  F.Left   := RunVirtComp.PopVar;
  F.Top    := RunVirtComp.PopVar;
  F.Caption:= RunVirtComp.PopVar;
  Owner    := RunVirtComp.PopVar;

  if Owner = 0 then
    TForm( RunVirtComp.Owner ).InsertControl( F )
  else if Owner <> -1 then
    TForm( Owner ).InsertControl( F );

  RunVirtComp.PushVar( Integer( F ) );

  WinVirtComp := RunVirtComp;
end;

function GetForm : Integer;
var
  I : Variant;
begin
  RunVirtComp.GetVar( 'TForm.FormPointer', I );
  result := I;
end;

procedure _TForm_Show;
var
  P : Integer;
begin
  P := GetForm;
  if P <> 0 then
    TForm( P ).Show;
  RunVirtComp.PushVar( 0 );
end;

procedure _TForm_MoveTo;
var
  P, X, Y : Integer;
begin
  P := GetForm;

  Y := RunVirtComp.PopVar;
  X := RunVirtComp.PopVar;

  if P <> 0 then
    TForm( P ).Canvas.MoveTo( X, Y );

  RunVirtComp.PushVar( 0 );
end;

procedure _TForm_LineTo;
var
  P, X, Y : Integer;
begin
  P := GetForm;

  Y := RunVirtComp.PopVar;
  X := RunVirtComp.PopVar;

  if P <> 0 then
    TForm( P ).Canvas.LineTo( X, Y );

  RunVirtComp.PushVar( 0 );
end;

procedure _TForm_GetPenPosX;
var
  P, X : Integer;
begin
  P := GetForm;

  X := 0;
  if P <> 0 then
    X := TForm( P ).Canvas.PenPos.X;

  RunVirtComp.PushVar( X );
end;

procedure _TForm_GetPenPosY;
var
  P, Y : Integer;
begin
  P := GetForm;

  Y := 0;
  if P <> 0 then
    Y := TForm( P ).Canvas.PenPos.Y;

  RunVirtComp.PushVar( Y );
end;

procedure _TForm_GetRect;
var
  P : Integer;
begin
  P := GetForm;
  with TForm( P ) do
    RunVirtComp.PushVar( VarArrayOf( [ Top, Left, Width, Height ] ) );
end;

procedure _TForm_GetHWND;
var
  P, H : Integer;
begin
  P := GetForm;
  H := 0;
  if P <> 0 then
    H := TForm( P ).Handle;

  RunVirtComp.PushVar( H );
end;

procedure _TForm_GetCaption;
var
  P : Integer;
  S : WideString;
begin
  P := GetForm;
  S := '';
  if P <> 0 then
    S := TForm( P ).Caption;

  RunVirtComp.PushVar( S );
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  VirtComp1.Run;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  Res : Variant;
begin
  VirtComp2.ExecFunction( 'PlayDiff', [ 'X^X' ], Res );
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  VirtComp3.Run;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  VirtComp4.Run;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  VirtComp5.Run;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  TempVirt := TVirtComp.Create( Self );
  TempVirt.ScriptFileName := 'fact1.w';

  if TempVirt.SaveBinProg then
    ShowMessage( 'File fact1.wb was created' );

  TempVirt.Free;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  TempVirt := TVirtComp.Create( Self );
  TempVirt.ScriptFileName := 'fact1.wb';
  TempVirt.LoadBinProg;
  TempVirt.Run;
  TempVirt.Free;
end;

procedure TForm1.Button8Click(Sender: TObject);
var
  Dummy : Variant;
begin
  VirtComp8.ExecFunction( 'Hanoi', [ 4, 'A', 'B', 'C' ], Dummy );
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  VirtComp9.Run;
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  VirtComp10.Run;
end;

procedure TForm1.Virtlanguagemanual1Click(Sender: TObject);
begin
  Application.HelpContext(0);
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  CurrentTime : LongInt;
begin
  Application.HelpFile := 'VIRT.HLP';
  CurrentTime := GetTickCount div 1000;
  while (( GetTickCount div 1000 ) < ( CurrentTime + 2 ) ) do
    Sleep( 1 );
end;

procedure TForm1.ComponentTVirtComp1Click(Sender: TObject);
begin
  Application.HelpContext(3000);
end;

procedure TForm1.WorkingwithVIRT1Click(Sender: TObject);
begin
  Application.HelpContext(2000);
end;

procedure TForm1.Abour1Click(Sender: TObject);
begin
  ShowMessage( 'Component TVirtComp demo program' + #13#10 + #13#10 +
               'Copyright (c) 1999 by A.Baranovsky' );
end;

procedure TForm1.VirtComp1BeforeParsing(var Sender: TVirtComp);
begin
  Sender.AppFunction( 'TForm.Init',       6, _TForm_Init );
  Sender.AppFunction( 'TForm.Show',       0, _TForm_Show );
  Sender.AppFunction( 'TForm.MoveTo',     2, _TForm_MoveTo );
  Sender.AppFunction( 'TForm.LineTo',     2, _TForm_LineTo );
  Sender.AppFunction( 'TForm.GetPenPosX', 0, _TForm_GetPenPosX );
  Sender.AppFunction( 'TForm.GetPenPosY', 0, _TForm_GetPenPosY );
  Sender.AppFunction( 'TForm.GetRect',    0, _TForm_GetRect );
  Sender.AppFunction( 'TForm.GetHWND',    0, _TForm_GetHWND );
  Sender.AppFunction( 'TForm.GetCaption', 0, _TForm_GetCaption );
end;

procedure _GetCurrentDate; external 'VIRTPLUG.DLL' name 'GETCURRENTDATE';
procedure _GetCurrentTime; external 'VIRTPLUG.DLL' name 'GETCURRENTTIME';

procedure TForm1.VirtComp9BeforeParsing(var Sender: TVirtComp);
begin
  Sender.AppSystemFunction( 'GetCurrentDate', 3, _GetCurrentDate );
  Sender.AppSystemFunction( 'GetCurrentTime', 4, _GetCurrentTime );
end;

end.
