-------------------------------------------------------------- 
--  Subject : Symbolic differentiation ( module )
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

constant 
  X    = 'X'
  PLUS = '+'    
  MULT = '*'    
  MINUS= '-'     
  DIV  = '/'
  UN   = '~'   
  LOG  = 'ln'   
  POW  = '^'     

  SP_L = '('
  SP_R = ')'
end

function IsVar( Term ) 
return ( ClassOf( Term ) = ClassString ) and ( Term = 'X' )

function IsConstant( Term )
return ClassOf( Term ) = ClassInteger

function IsZero( Term )
return IsConstant( Term ) and ( Term = 0 )

function IsUnit( Term )
return IsConstant( Term ) and ( Term = 1 )

function IsPow( Term )
return ( ClassOf( Term ) = ClassArray ) and ( Term[1] = POW )

function IsMult( Term )
return ( ClassOf( Term ) = ClassArray ) and ( Term[1] = MULT )

function IsAdd( Term )
return ( ClassOf( Term ) = ClassArray ) and ( Term[1] = PLUS )

function IsSub( Term )
return ( ClassOf( Term ) = ClassArray ) and ( Term[1] = MINUS )

function IsNeg( Term )
return ( ClassOf( Term ) = ClassArray ) and ( Term[1] = UN )

function Equal( U, V ) 
  if ClassOf( U ) = ClassOf( V ) then
    R := U = V 
  else
    R := FALSE
  end  
return R

class TFailrue : Exception 
  function Init( InitMessage ) constructor
  function ShowError() 
end

implementation TFailrue

  local Message

  function Init( InitMessage )
    Exception.Create()
    Message := InitMessage 
  return 0

  function ShowError()
    writeln( Message )
  return 0 
end

return
