--------------------------------------------------------------  
--  Subject : Backtracking, Knight Tour
--  Copyright (c) 1999 by A.Baranovsky
--------------------------------------------------------------

  class KnightsTour
    function Init( InitN ) constructor
    function Tour( X0, Y0 ) 
    function Print()
  end

  implementation KnightsTour

    local h, dx, dy, N, Nsqr

    function Init( InitN )                
      dx := [ 2, 1, -1, -2, -2, -1,  1,  2 ]
      dy := [ 1, 2,  2,  1, -1, -2, -2, -1 ] 
      N  := InitN
      Nsqr := N * N 
      h := array( N )
      for I:=1 to N do
        h[ I ] := array( N )
      end
    return 0

    function TryTour( I, X, Y )
      K := 0
      repeat
        K := K + 1
        q := FALSE
        U := X + dx[ K ]
        V := Y + dy[ K ]

        if ( 1 <= U ) and ( U <= N ) and ( 1 <= V ) and ( V <= N ) and ( h[ U, V ] = 0 ) then
          h[ U, V ] := I
          if I < Nsqr then
            q := TryTour( I + 1, U, V )
            if not q then
              h[ U, V ] := 0
            end 
          else
            q := TRUE 
          end 
        end
      until q or ( K = 8 )
    return q

    function Tour( X0, Y0 )
      for I:=1 to N do
        for J:=1 to N do
          h[ I, J ] := 0
        end
      end
      h[ X0, Y0 ] := 1 
    return TryTour( 2, X0, Y0 )

    function Print()
      for I:=1 to N do
        writeln( h[ I ] )
      end 
    return 0   

  end

  object T( 5 ) : KnightsTour
  if T.Tour( 1, 1 ) then
    T.Print()
  else
    writeln( 'Solution not found' )
  end 

return
